package net.moioli.complessi;

/**
 * Rappresentazioni alternative dei numeri complessi
 * 
 * Versione originale: 2/12/2003
 * Versione JML: 28/11/2007
 * Autore: Silvio Moioli
 */

import java.awt.Color;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import net.moioli.grafici.Grafico;
import net.moioli.grafici.JGrafico;

/**
 * Interfaccia utente del programma.
 */
public class Main extends javax.swing.JFrame {

	/**
	 * ID per la serializzazione.
	 */
	private static final long serialVersionUID = 1L;
	
	/**
	 *  Massimo valore rappresentato dal grafico.
     */
	private static final double FONDOSCALA = 10;

	/** Creates new form FormeComplesse */
	public Main() {
		initComponents();
		jTextField1KeyPressed(new KeyEvent(this, 0, 0, 0, 0, '0'));
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jGrafico1 = new net.moioli.grafici.JGrafico();

        getContentPane().setLayout(new java.awt.GridLayout(3, 1));

        setTitle("Conversioni complesse");
        setMaximizedBounds(new java.awt.Rectangle(0, 0, 800, 600));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridLayout(1, 5));

        jLabel1.setFont(new java.awt.Font("Dialog", 3, 12));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setLabelFor(jPanel1);
        jLabel1.setText("Prima forma (algebrica)");
        jPanel1.add(jLabel1);

        jTextField1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField1.setText("-2+j3");
        jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextField1KeyPressed(evt);
            }
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField1KeyReleased(evt);
            }
        });

        jPanel1.add(jTextField1);

        getContentPane().add(jPanel1);

        jPanel2.setLayout(new java.awt.GridLayout(1, 5));

        jLabel4.setFont(new java.awt.Font("Dialog", 3, 12));
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setLabelFor(jPanel2);
        jLabel4.setText("Seconda forma  (esponenziale)");
        jPanel2.add(jLabel4);

        jTextField2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField2.setText("3e^-6");
        jTextField2.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextField2KeyPressed(evt);
            }
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField2KeyReleased(evt);
            }
        });

        jPanel2.add(jTextField2);

        getContentPane().add(jPanel2);

        jPanel3.setLayout(new java.awt.GridLayout(1, 2));

        jLabel7.setFont(new java.awt.Font("Dialog", 3, 12));
        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel7.setLabelFor(jPanel3);
        jLabel7.setText("Forma grafica");
        jPanel3.add(jLabel7);

        jPanel4.setLayout(new java.awt.GridLayout(1, 0));

        jLabel2.setFont(new java.awt.Font("Dialog", 2, 12));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("(Cliccare per il nuovo numero)");
        jPanel4.add(jLabel2);

        jGrafico1.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseReleased(MouseEvent e) {
				super.mouseReleased(e);
				jGrafico1MouseClicked(e);
			}
        });

        jPanel4.add(jGrafico1);

        jPanel3.add(jPanel4);

        getContentPane().add(jPanel3);

        pack();
    }

	private void jTextField2KeyReleased(java.awt.event.KeyEvent evt) {// GEN-FIRST:event_jTextField2KeyReleased
		jTextField2KeyPressed(evt);
	}// GEN-LAST:event_jTextField2KeyReleased

	private void jTextField1KeyReleased(java.awt.event.KeyEvent evt) {// GEN-FIRST:event_jTextField1KeyReleased
		jTextField1KeyPressed(evt);
	}// GEN-LAST:event_jTextField1KeyReleased

	private void jTextField2KeyPressed(java.awt.event.KeyEvent evt) {// GEN-FIRST:event_jTextField2KeyPressed
		try {
			NumeroComplesso z = Parser.parse(jTextField2.getText());
			// aggiorno la prima forma
			jTextField2.setBackground(Color.WHITE);

			// aggiorno la seconda forma
			if (Parser.isAlgebrica(jTextField2.getText())) {
				jTextField1.setText(new FormaEsponenziale(z).toString());
			} else {
				jTextField1.setText(new FormaAlgebrica(z).toString());
			}
			jTextField1.setBackground(Color.WHITE);

			// aggiorno la forma grafica
			Grafico g = new Grafico();
			g.add(new FormaGrafica(z));
			g.setMinX(-FONDOSCALA);
			g.setMaxX(FONDOSCALA);
			jGrafico1.setGrafico(g);
		} catch (ParseException e) {
			jTextField2.setBackground(Color.RED);
		}
	}// GEN-LAST:event_jTextField2KeyPressed

	private void jTextField1KeyPressed(java.awt.event.KeyEvent evt) {// GEN-FIRST:event_jTextField1KeyPressed
		try {
			NumeroComplesso z = Parser.parse(jTextField1.getText());

			// aggiorno la prima forma
			jTextField1.setBackground(Color.WHITE);

			// aggiorno la seconda forma
			if (Parser.isAlgebrica(jTextField1.getText())) {
				jTextField2.setText(new FormaEsponenziale(z).toString());
			} else {
				jTextField2.setText(new FormaAlgebrica(z).toString());
			}
			jTextField2.setBackground(Color.WHITE);

			// aggiorno la forma grafica
			Grafico g = new Grafico();
			g.add(new FormaGrafica(z));
			g.setMinX(-FONDOSCALA);
			g.setMaxX(FONDOSCALA);
			jGrafico1.setGrafico(g);
		} catch (ParseException e) {
			jTextField1.setBackground(Color.RED);
		}
	}// GEN-LAST:event_jTextField1KeyPressed

	private void jGrafico1MouseClicked(java.awt.event.MouseEvent evt) {// GEN-FIRST:event_jGrafico1MouseClicked
		Rectangle r = jGrafico1.getBounds();
		double maxX = r.getWidth();
		double maxY = r.getHeight();
		double myX = evt.getX();
		double myY = evt.getY();
		double x1 = (myX - maxX / 2) / maxX * FONDOSCALA * 2;
		double y1 = (maxY / 2 - myY) / maxY * FONDOSCALA * 2;
		NumeroComplesso z = new FormaAlgebrica(x1, y1);

		// aggiorno la forma algebrica
		jTextField1.setBackground(Color.WHITE);
		jTextField1.setText(z.toString());

		// aggiorno la forma esponenziale
		jTextField2.setBackground(Color.WHITE);
		jTextField2.setText(new FormaEsponenziale(z).toString());

		// aggiorno la forma grafica
		Grafico g = new Grafico();
		g.add(new FormaGrafica(z));
		g.setMinX(-FONDOSCALA);
		g.setMaxX(FONDOSCALA);
		jGrafico1.setGrafico(g);
		repaint();
	}// GEN-LAST:event_jGrafico1MouseClicked

	/** Exit the Application */
	private void exitForm(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_exitForm
		System.exit(0);
	}// GEN-LAST:event_exitForm

	/**
	 * @param args
	 *            the command line arguments
	 */
	public static void main(String args[]) {
		new Main().setVisible(true);
	}

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private net.moioli.grafici.JGrafico jGrafico1 = new JGrafico();
	private javax.swing.JLabel jLabel1 = new JLabel();
	private javax.swing.JLabel jLabel2 = new JLabel();
	private javax.swing.JLabel jLabel4 = new JLabel();
    private javax.swing.JLabel jLabel7 = new JLabel();
	private javax.swing.JPanel jPanel1 = new JPanel();
	private javax.swing.JPanel jPanel2 = new JPanel();
	private javax.swing.JPanel jPanel3 = new JPanel();
	private javax.swing.JPanel jPanel4 = new JPanel();
	private javax.swing.JTextField jTextField1 = new JTextField();
	private javax.swing.JTextField jTextField2 = new JTextField();
	// End of variables declaration//GEN-END:variables

}
