package net.moioli.grafici;

/**
 * Rappresentazioni alternative dei numeri complessi
 * 
 * Versione originale: 2/12/2003
 * Versione JML: 28/11/2007
 * Autore: Silvio Moioli
 */

import java.util.Collection;
import java.util.Iterator;

/**
 * Permette di usare un oggetto Collection come se fosse una
 * CompatibleCollection.
 */
public class CollectionWrapper implements CompatibleCollection {

	Collection wrapped;

	/**
	 * @param wrapped
	 */
	public CollectionWrapper(Collection wrapped) {
		this.wrapped = wrapped;
	}

	/**
	 * @return
	 */
	public int getCollectionSize() {
		return wrapped.size();
	}

	/**
	 * @param arg0
	 * @return
	 */
	public boolean add(Object arg0) {
		return wrapped.add(arg0);
	}

	/**
	 * @param arg0
	 * @return
	 */
	public boolean addAll(Collection arg0) {
		return wrapped.addAll(arg0);
	}

	/**
	 * 
	 */
	public void clear() {
		wrapped.clear();
	}

	/**
	 * @param arg0
	 * @return
	 */
	public boolean contains(Object arg0) {
		return wrapped.contains(arg0);
	}

	/**
	 * @param arg0
	 * @return
	 */
	public boolean containsAll(Collection arg0) {
		return wrapped.containsAll(arg0);
	}

	/*
	 * (non Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object arg0) {
		return wrapped.equals(arg0);
	}

	/*
	 * (non Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return wrapped.hashCode();
	}

	/**
	 * @return
	 */
	public boolean isEmpty() {
		return wrapped.isEmpty();
	}

	/**
	 * @return
	 */
	public Iterator iterator() {
		return wrapped.iterator();
	}

	/**
	 * @param arg0
	 * @return
	 */
	public boolean remove(Object arg0) {
		return wrapped.remove(arg0);
	}

	/**
	 * @param arg0
	 * @return
	 */
	public boolean removeAll(Collection arg0) {
		return wrapped.removeAll(arg0);
	}

	/**
	 * @param arg0
	 * @return
	 */
	public boolean retainAll(Collection arg0) {
		return wrapped.retainAll(arg0);
	}

	/**
	 * @return
	 */
	public Object[] toArray() {
		return wrapped.toArray();
	}

	/**
	 * @param arg0
	 * @return
	 */
	public Object[] toArray(Object[] arg0) {
		return wrapped.toArray(arg0);
	}

	/*
	 * (non Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return wrapped.toString();
	}
}
