package net.moioli.grafici;

/**
 * Rappresentazioni alternative dei numeri complessi
 * 
 * Versione originale: 2/12/2003
 * Versione JML: 28/11/2007
 * Autore: Silvio Moioli
 */

import java.util.Collection;
import java.util.Iterator;

/**
 * Permette di usare un oggetto CompatibleCollection con l'interfaccia standard
 * di Collection.
 */
public class CompatibleCollectionWrapper implements Collection {

	CompatibleCollection wrapped = null;

	/**
	 * @param wrapped
	 */
	public CompatibleCollectionWrapper(CompatibleCollection wrapped) {
		this.wrapped = wrapped;
	}

	/**
	 * @return
	 */
	public int size() {
		return wrapped.getCollectionSize();
	}

	/**
	 * @param o
	 * @return
	 */
	public boolean add(Object o) {
		return wrapped.add(o);
	}

	/**
	 * @param c
	 * @return
	 */
	public boolean addAll(Collection c) {
		return wrapped.addAll(c);
	}

	/**
	 * 
	 */
	public void clear() {
		wrapped.clear();
	}

	/**
	 * @param o
	 * @return
	 */
	public boolean contains(Object o) {
		return wrapped.contains(o);
	}

	/**
	 * @param c
	 * @return
	 */
	public boolean containsAll(Collection c) {
		return wrapped.containsAll(c);
	}

	/*
	 * (non Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object arg0) {
		return wrapped.equals(arg0);
	}

	/*
	 * (non Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return wrapped.hashCode();
	}

	/**
	 * @return
	 */
	public boolean isEmpty() {
		return wrapped.isEmpty();
	}

	/**
	 * @return
	 */
	public Iterator iterator() {
		return wrapped.iterator();
	}

	/**
	 * @param o
	 * @return
	 */
	public boolean remove(Object o) {
		return wrapped.remove(o);
	}

	/**
	 * @param c
	 * @return
	 */
	public boolean removeAll(Collection c) {
		return wrapped.removeAll(c);
	}

	/**
	 * @param c
	 * @return
	 */
	public boolean retainAll(Collection c) {
		return wrapped.retainAll(c);
	}

	/**
	 * @return
	 */
	public Object[] toArray() {
		return wrapped.toArray();
	}

	/**
	 * @param a
	 * @return
	 */
	public Object[] toArray(Object[] a) {
		return wrapped.toArray(a);
	}

	/*
	 * (non Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return wrapped.toString();
	}

}
