package net.moioli.grafici;

/**
 * Rappresentazioni alternative dei numeri complessi
 * 
 * Versione originale: 2/12/2003
 * Versione JML: 28/11/2007
 * Autore: Silvio Moioli
 */

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

/**
 * Per modificare il modello associato al commento di questo tipo generato,
 * aprire Finestra&gt;Preferenze&gt;Java&gt;Generazione codice&gt;Codice e
 * commenti
 */
public interface IGrafico extends CompatibleCollection {
	/**
	 * Disegna il grafico sull'oggetto Graphics2D passato
	 * 
	 * @param g
	 *            l'oggetto su cui disegnare
	 */
	public void disegnami(Graphics g, Rectangle clip);

	// Getters and Setters
	public Color getColor();

	/**
	 * @param color
	 *            The color to set.
	 */
	public void setColor(Color color);

	/**
	 * @return Returns the maxX.
	 */
	public double getMaxX();

	/**
	 * @param maxX
	 *            The maxX to set.
	 */
	public void setMaxX(double maxX);

	/**
	 * @return Returns the minX.
	 */
	public double getMinX();

	/**
	 * @param minX
	 *            The minX to set.
	 */
	public void setMinX(double minX);

	/**
	 * @return Returns the maxY.
	 */
	public double getMaxY();

	/**
	 * @param maxY
	 *            The maxY to set.
	 */
	public void setMaxY(double maxY);

	/**
	 * @return Returns the minY.
	 */
	public double getMinY();

	/**
	 * @param minY
	 *            The minY to set.
	 */
	public void setMinY(double minY);

	/**
	 * @return Returns the precisionePixel.
	 */
	public int getPrecisionePixel();

	/**
	 * @param precisionePixel
	 *            The precisionePixel to set.
	 */
	public void setPrecisionePixel(int precisionePixel);
}